// #autoload
// #name = ma7AutoDemo
// #version = 5.0
// #date = December 17, 2001
// #author =  {DD}ma7hatter
// #warrior =  ma7hatter		
// #email = ma7hatter@darkdemons.net
// #web = http://www.darkdemons.net
// #description = Automatically starts and stops demos for you
// #credit = All my clanmates
// #status = Beta
// #config = ma7Options
// #readme = scripts/autoexec/ma7README.txt

new GuiControl(ma7Options)
{
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 10";
	extent = "400 310";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";
	
	new ShellToggleButton()	{
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 32";
		extent = "200 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::ma7MatchStart::on";
		helpTag = "0";
		text = "Only start demos after match start";
		maxLength = "255";
	};
	
	new ShellToggleButton()	{
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 64";
		extent = "200 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::playBackHud::on";
		helpTag = "0";
		text = "Automatically start the playback hud";
		maxLength = "255";
	};
	
	new ShellToggleButton()	{
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 96";
		extent = "200 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::pauseAfter::on";
		helpTag = "0";
		text = "Pause during the score screen";
		maxLength = "255";
	};
};

if ($pref::ma7MatchStart::on $= "") $pref::ma7MatchStart::on = true;
if ($pref::playBackHud::on $= "") $pref::playBackHud::on = true;
if ($pref::pauseAfter::on $= "") $pref::pauseAfter::on = true;

//------------------------------------------------------------

package ma7AutoDemo 
{
	function StartSelectedDemo()
	{
		$ma7IsPlaying = true;
		if($pref::playBackHud::on)
			toggleDemoPlaybackHud();
		
		parent::StartSelectedDemo();
	}
	
	function demoPlaybackComplete()
	{	
		$ma7IsPlaying = false;
		
		parent::demoPlaybackComplete();
	}
	
	function defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		parent::defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
		
		if(!$ma7IsPlaying)
		{
			if((StrStr(%msgString, "You are in mission") != -1) && !$pref::ma7MatchStart::on)
				schedule(1, 0, beginDemoRecord);
								
			if(StrStr(%msgString, "Match started") != -1)
				schedule(1, 0, beginDemoRecord);
				
			if(StrStr(%msgString, "Match starts in 1 sec") != -1)
				stopDemoRecord();
				
			if(StrStr(%msgString, "Match has ended") != -1)
				schedule(2000, 0, stopDemoRecord);
		}
		else
			if(StrStr(%msgString, "Match has ended") != -1 && $pref::pauseAfter::on)
				toggleDemoPause();
	}
};
$ma7IsPlaying = false;
$ma7Temp = false;
activatePackage(ma7AutoDemo);